/**
* jQuery Update Time Posts 
* JPTime.js v.0.1
* @author:  alex-borisi 
* @date:    22.07.2015
 */

function JPTimeMap(selector, maximum) 
{
    // Массив обновляемых элементов
    var timeMapArr = [];
    
    // Текущая дата
    var Time = new Date(); 

    // Время в формате timestamp
    var phptime = Math.floor(Time.getTime() / 1000);

    // Выбираем все элементы с указанным селектором
    $(selector).each(function() { 
    
        // Время в формате timestamp
        var uid = $(this).attr('data-time'); 
        
        // Помещаем время за последние 24 часа
        if (uid > (phptime - maximum))
            timeMapArr[uid] = uid;
    });
    
    return timeMapArr;   
}

function JPTime(option) 
{
    // Копия текущего объекта
    var parent = this;
    
    // Опции работы скрипта
    var options = $.extend({
        interval: 5000,
        selector: '.time',
        maximum: 86400,
        autoInterval: false,
        timex: 60,
    }, option);
    
    /**
    * Cклонение слов по типу 
    * 1 секунда, 2 секунды, 5 секунд
    */
    this.case_number = function(num, one, two, more) {
        var l2 = num.substr(num.length - 2, 2);
        if ((l2 >= 5) && (l2 <= 20))
            return more;
        
        var l = num.substr(num.length - 1, 1);
        switch (l) {
            case '1':
                return one;
            case '2':
                return two;
            case '3':
                return two;
            case '4':
                return two;
            default:
                return more;
        }
    };
    
    /**
    * Формат времени (сек / мин / час назад)
    */
    this.timeOut = function(time) {
        var mTime = new Date();
        
        // Текущее время
        var realtime = Math.floor(mTime.getTime() / 1000 + 22);
        
        // Шаблон текста
        var text = {2: 'две', 3: 'три', 4: 'четыре'};
        
        // Время по секундам, минутам, часам и дате
        if (time == realtime) 
            return 'только что';
        else if (time > (realtime - 60)) {
            var sec = Math.floor(realtime - time);
            return (text[sec] ? text[sec] : sec) + ' секунд' + parent.case_number(String(sec), 'а', 'ы', '') + ' назад';
        } else if (time > (realtime - 3600)) {
            var minutes = Math.floor((realtime - time) / 60);
            return (text[minutes] ? text[minutes] : minutes) + ' минут' + parent.case_number(String(minutes), 'у', 'ы', '') + ' назад';
        } else if (time > (realtime - 86400)) {
            text = {2: 'два', 3: 'три', 4: 'четыре'};
            var hours = Math.floor((realtime - time) / 3600);
            return hours + ' час' + parent.case_number(String(hours), '', 'а', 'ов') + ' назад';
        } else {
            var t = new Date();
            t.setTime(time * 1000);
            return t.getDate()+'.'+
                   t.getMonth()+'.'+
                   t.getFullYear()+' в '+
                   t.getHours()+':'+
                   t.getMinutes()+':'+
                   t.getSeconds();
        }
    };
    
    /**
    * Запуск скрипта
    */
    this.start = function() {
        
        // Массив обновляемых элементов
        var timeMap = JPTimeMap(options.selector, options.maximum); 
        
        // Если есть что то в массиве, то запускаем обновление
        if (parent.count(timeMap) > '0') {
            interval = setInterval(function() {
                
                // Текущая метка времени
                jtime = Math.floor(new Date().getTime() / 1000 + 22);
                
                // Исполняющий цикл
                for(var p in timeMap) {
                    var newTime = parent.timeOut(p);
                    $('[data-time = "' + p + '"]').text(newTime);
                    endTime = p; 
                }
                
                // Наименьшее время из массива
                end = (jtime - endTime);
                
                // Корректировка интервала
                if (options.autoInterval === true) 
                    if (end > options.timex) 
                        options.interval = 60000, options.timex += end;             
                
            }, options.interval);
        }
    };
    
    /**
    * Псевдоним php функции count()
    */
    this.count = function(arr) {
        var cnt = 0;
        for (var i in arr) {
            if (i) 
               cnt++;
        }
        return cnt;
    };
}